##
## Copyright (c) 2021 The Yaook Authors.
##
## This file is part of Yaook.
## See https://yaook.cloud for further info.
##
## Licensed under the Apache License, Version 2.0 (the "License");
## you may not use this file except in compliance with the License.
## You may obtain a copy of the License at
##
##     http://www.apache.org/licenses/LICENSE-2.0
##
## Unless required by applicable law or agreed to in writing, software
## distributed under the License is distributed on an "AS IS" BASIS,
## WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
## See the License for the specific language governing permissions and
## limitations under the License.
##
FROM almalinux:8 AS venv-builder

ARG openstack_release=2023.1

COPY files/ /build_files

RUN set -eux ; \
    yum install -y \
        gcc \
        patch \
        python38-devel \
        python38 \
        git ; \
    python3 -m venv /usr/venv-ironic ; \
    . /usr/venv-ironic/bin/activate ; \
    (git clone https://github.com/openstack/requirements.git --depth 1 --branch "stable/${openstack_release}" \
      || git clone https://github.com/openstack/requirements.git --depth 1 --branch "${openstack_release}-eol" \
      || git clone https://github.com/openstack/requirements.git --depth 1 --branch "unmaintained/${openstack_release}") ; \
    (git clone https://github.com/openstack/ironic-inspector.git --depth 1 --branch "stable/${openstack_release}" \
      || git clone https://github.com/openstack/ironic-inspector.git --depth 1 --branch "${openstack_release}-eol" \
      || git clone https://github.com/openstack/ironic-inspector.git --depth 1 --branch "unmaintained/${openstack_release}") ; \
    # for 2024.2 the patch is not needed anymore:
    patch -d ironic-inspector -p 1 -i /build_files/Ignore-resolve-error.patch; \
    pip3 install -c requirements/upper-constraints.txt pymysql python-memcached pymemcache ironic-inspector/ ;


FROM almalinux:8

ARG openstack_release=2023.1

ENV VIRTUAL_ENV=/usr/venv-ironic

COPY --from=venv-builder $VIRTUAL_ENV $VIRTUAL_ENV

RUN mkdir /etc/ironic-inspector

RUN set -eux ; \
    yum install -y \
        python38 \
        sudo \
        which ; \
    yum clean all

ENV PATH="$VIRTUAL_ENV/bin:$PATH"

CMD ["ironic-inspector"]
